breed [people person]
globals [
  black-patches

  trains-cords time-counter
  current-train-arived

  platform-a-exits
  platform-b-exits

  transfered-to-b-counter
  transfered-to-a-counter

  path-from-b-stairs-to-right-a
  path-from-b-stairs-to-middle-a
  path-from-b-main-to-right-a
  path-from-b-main-to-middle-a
  path-from-a-right-to-stairs-b
  path-from-a-right-to-main-b
  path-from-a-middle-to-stairs-b
  path-from-a-middle-to-main-b

  transfer-tunnel-exit-main-b
  transfer-tunnel-exit-left-stairs-b
  transfer-tunnel-exit-right-stairs-b
  transfer-tunnel-exit-left-ecsalator-a
  transfer-tunnel-exit-middle-ecsalator-a
  transfer-tunnel-exit-right-ecsalator-a

  train0-exits train1-exits train2-exits train3-exits

  best-path-b-i
  best-path-b-ii
  best-path-a-i
  best-path-a-ii

  best-distance-b-i
  best-distance-b-ii
  best-distance-a-i
  best-distance-a-ii

  train-schedule-train0-7-8
  train-schedule-train1-7-8
  train-schedule-train2-7-8
  train-schedule-train3-7-8

  train-schedule-train0-17-18
  train-schedule-train1-17-18
  train-schedule-train2-17-18
  train-schedule-train3-17-18

  count-mins
]


people-own [
  pace current-step
  arriving-in-train
  transfer-exit transfer-exit-steps current-transfer-exit-step
  ttl
  path
  path-distance
]



to setup
  clear-all

  ;load metro map
  import-pcolors "metro.png"
  import-drawing "metro-overlay.png"

  ;helpers
  set black-patches patches with [pcolor = black or pcolor = orange]

  ;trains info
  set trains-cords (list (list 8 -6 142 -3) (list 8 -28 141 -26) (list 8 -124 142 -121) (list 8 -146 142 -143))
  set current-train-arived 0

  set train-schedule-train0-7-8 (list 1 5 8 12 15 19 22 25 28 31 34 36 39 41 44 46 49 51 53 56 58)
  set train-schedule-train1-7-8 (list 1 4 6 8 11 13 15 18 20 22 25 27 29 32 34 36 39 41 43 46 48 50 53 55 57)
  set train-schedule-train2-7-8(list 0 3 6 9 12 15 18 20 23 25 28 30 32 35 37 39 42 44 46 49 51 53 56 58)
  set train-schedule-train3-7-8 (list 1 5 10 14 18 21 25 28 31 34 37 39 42 45 48 51 54 56 59)

  set train-schedule-train0-17-18 (list 0 3 5 8 10 13 15 18 20 23 25 28 30 33 35 38 40 43 45 48 50 53 55 58)
  set train-schedule-train1-17-18 (list 1 3 6 8 11 13 16 18 21 23 26 28 31 34 36 39 42 45 48 51 54 58)
  set train-schedule-train2-17-18(list 1 4 7 10 13 16 19 22 25 28 31 34 37 40 43 47 50 54 57)
  set train-schedule-train3-17-18 (list 2 5 8 11 14 17 20 23 26 29 32 35 38 41 44 47 50 53 56 59)

  ;train exists
  set train0-exits patches with [pcolor = 7.5 and pycor = -8]
  set train1-exits patches with [pcolor = 7.5 and pycor = -24]
  set train2-exits patches with [pcolor = 7.5 and pycor = -126]
  set train3-exits patches with [pcolor = 7.5 and pycor = -142]

  ;platform-exits
  set platform-a-exits patches with [pcolor = 44.9]
  set platform-b-exits patches with [pcolor = 66.1]

  ;path b -> a
  set path-from-b-stairs-to-right-a (list (list 28 -40) (list 28 -71) (list 70 -86) (list 70 -107) (list 101 -107))
  set path-from-b-stairs-to-middle-a (list (list 28 -40) (list 28 -71) (list 70 -86) (list 101 -86))
  set path-from-b-main-to-right-a (list (list 92 -44) (list 121 -45) (list 122 -83) (list 124 -88) (list 124 -104) (list 100 -104))
  set path-from-b-main-to-middle-a (list (list 92 -44) (list 121 -45) (list 122 -83) (list 100 -83))

  ;path a -> b
  set path-from-a-right-to-stairs-b (list (list 96 -104) (list 73 -104) (list 73 -84) (list 31 -69) (list 32 -42))
  set path-from-a-right-to-main-b (list (list 96 -104) (list 127 -107) (list 127 -40))
  set path-from-a-middle-to-stairs-b (list (list 96 -83) (list 72 -83) (list 31 -69) (list 32 -42))
  set path-from-a-middle-to-main-b (list (list 96 -83) (list 127 -83) (list 127 -40))

  ;transfer tunnel exit b side
  set transfer-tunnel-exit-main-b patches with [pxcor >= 88 and pxcor <= 89 and pycor >= -46 and pycor <= -38]
  set transfer-tunnel-exit-left-stairs-b patches with [pxcor >= 35 and pxcor <= 36 and pycor >= -45 and pycor <= -38]
  set transfer-tunnel-exit-right-stairs-b patches with [pxcor >= 24 and pxcor <= 25 and pycor >= -45 and pycor <= -38]

  ;transfer tunnel exit b side
  set transfer-tunnel-exit-left-ecsalator-a patches with [pxcor >= 98 and pxcor <= 102 and pycor >= -77 and pycor <= -76]
  set transfer-tunnel-exit-middle-ecsalator-a patches with [pxcor >= 98 and pxcor <= 102 and pycor >= -92 and pycor <= -91]
  set transfer-tunnel-exit-right-ecsalator-a patches with [pxcor >= 98 and pxcor <= 102 and pycor >= -114 and pycor <= -113]

  ;init best distance storage
  set best-distance-b-i 100000
  set best-distance-b-ii 100000
  set best-distance-a-i 100000
  set best-distance-a-ii 100000

  ;init best path storage
  set best-path-b-i (list)
  set best-path-b-ii (list)
  set best-path-a-i (list)
  set best-path-a-ii (list)

  ;init values for display
  set transfered-to-b-counter 0
  set transfered-to-a-counter 0

  create-people-in-arriving-train

  reset-ticks
end

to go
  ;for tick mesuring
  set time-counter time-counter + 1

  if time-counter mod frekvence-prijezdu = 0 [
    train-arives
  ]

  ask people [
    move
  ]

  tick
end

to train-arives
  ; reset time after one hour
  if count-mins > 59 [
    set count-mins 0
  ]

  ifelse cas-simulace = "7-8" [
    train-arives-7-8
  ]
  [
    train-arives-17-18
  ]

  set count-mins count-mins + 1
end

to train-arives-7-8
  if member? count-mins train-schedule-train0-7-8 [
    set current-train-arived 0
    create-people-in-arriving-train
  ]

  if member? count-mins train-schedule-train1-7-8 [
    set current-train-arived 1
    create-people-in-arriving-train
  ]

  if member? count-mins train-schedule-train2-7-8 [
    set current-train-arived 2
    create-people-in-arriving-train
  ]

  if member? count-mins train-schedule-train3-7-8 [
    set current-train-arived 3
    create-people-in-arriving-train
  ]
end

to train-arives-17-18
  if member? count-mins train-schedule-train0-17-18 [
    set current-train-arived 0
    create-people-in-arriving-train
  ]

  if member? count-mins train-schedule-train1-17-18 [
    set current-train-arived 1
    create-people-in-arriving-train
  ]

  if member? count-mins train-schedule-train2-17-18 [
    set current-train-arived 2
    create-people-in-arriving-train
  ]

  if member? count-mins train-schedule-train3-17-18 [
    set current-train-arived 3
    create-people-in-arriving-train
  ]
end

to create-people-in-arriving-train
  let spawn-mean 100
  let spawn-stdev 5

  ifelse cas-simulace = "7-8" [
    ifelse current-train-arived = 0 or  current-train-arived = 1 [
      set spawn-mean 118
      set spawn-stdev 12
    ]
    [
      set spawn-mean 128
      set spawn-stdev 6
    ]
  ]
  [
    ifelse current-train-arived = 0 or  current-train-arived = 1 [

      set spawn-mean 128
      set spawn-stdev 6
    ]
    [
      set spawn-mean 118
      set spawn-stdev 12
    ]
  ]

  create-people random-normal 118 12 [
    let train-coord item current-train-arived trains-cords
    let min-x (item 0 train-coord)
    let min-y (item 1 train-coord)
    let max-x (item 2 train-coord)
    let max-y (item 3 train-coord)
    let valid-coords? false
    while [not valid-coords?] [
      let x (min-x + random (max-x - min-x))
      let y (min-y + random (max-y - min-y))
      if [pcolor] of patch x y != 133.1 and not any? turtles-on patch x y  [
        setxy x y
        set valid-coords? true
      ]
    ]
    set current-transfer-exit-step 0
    set arriving-in-train current-train-arived
    set size 1.5
    set current-step "exit-train"
    set pace precision random-normal 1 0.2 2
    set ttl 50
    ifelse current-train-arived = 0 or current-train-arived = 1 [
      set color green + 10
    ][
      set color yellow + 2
    ]
    set path (list )
  ]
end

to move
  set ttl ttl - 1
  ifelse ttl > 0 and
  (patch-ahead pace != nobody) and
  ((not any? turtles-on patch-ahead pace) or
    ((count turtles-on patch-ahead pace = 1) and (one-of turtles-on patch-ahead pace = self))
    )[

    if current-step = "exit-train" [
      exit-trian
    ]

    if current-step = "go-to-nearest-platform-exit" [
      go-to-nearest-platform-exit
    ]

    if current-step = "enter-transfer-tunnels" [
      enter-transfer-tunnels
    ]

    if current-step = "exit-transfer-tunnels" [
      exit-transfer-tunnels
    ]
  ] [
    ifelse ttl <= 0 [
      die
    ][
      rt random 180
    ]
  ]
end

to exit-trian
  let best-target get-best-train-exit

  if best-target = patch-here [
    set best-target min-one-of black-patches [distance myself]
  ]

  face best-target

  ifelse member? ([pcolor] of patch-ahead pace) [black orange]  [
    pace-movement
    set current-step "go-to-nearest-platform-exit"
  ][
    avoid-walls-collision
    attempt-movement
  ]
end

to go-to-nearest-platform-exit
  let best-target 0
  let exit-color 0
  ifelse arriving-in-train = 0 or arriving-in-train = 1 [
    set best-target min-one-of platform-b-exits [distance myself]
    set exit-color 66.1
  ] [
    set best-target min-one-of platform-a-exits [distance myself]
    set exit-color 44.9
  ]
  face best-target

  ifelse [pcolor] of patch-ahead pace = exit-color [
    pace-movement
    set current-step "enter-transfer-tunnels"
  ][
    avoid-walls-collision
    attempt-movement
  ]
end

to enter-transfer-tunnels
  let rand3 random 3
  ; schody B levo
  if xcor >= 78 and xcor <= 80 and ycor >= -19 and ycor <= -12 [
    setxy 25 ycor - 26

    if rand3 = 0 [
      set transfer-exit transfer-tunnel-exit-right-ecsalator-a
      set transfer-exit-steps modify-x-y-values path-from-b-stairs-to-right-a
    ]

    if rand3 = 1 [
      set transfer-exit transfer-tunnel-exit-middle-ecsalator-a
      set transfer-exit-steps modify-x-y-values path-from-b-stairs-to-middle-a
    ]

    if rand3 = 2 [
      set transfer-exit transfer-tunnel-exit-left-ecsalator-a
      set transfer-exit-steps modify-x-y-values path-from-b-stairs-to-middle-a
    ]
  ]

  ; schody B pravo
  if xcor >= 88 and xcor <= 90 and ycor >= -19 and ycor <= -12 [
    setxy 35 ycor - 26

    if rand3 = 0 [
      set transfer-exit transfer-tunnel-exit-right-ecsalator-a
      set transfer-exit-steps modify-x-y-values path-from-b-stairs-to-right-a
    ]

    if rand3 = 1 [
      set transfer-exit transfer-tunnel-exit-middle-ecsalator-a
      set transfer-exit-steps modify-x-y-values path-from-b-stairs-to-middle-a
    ]

    if rand3 = 2 [
      set transfer-exit transfer-tunnel-exit-left-ecsalator-a
      set transfer-exit-steps modify-x-y-values path-from-b-stairs-to-middle-a
    ]
  ]

  ; hl vychod B
  if xcor >= 141 and xcor <= 143 and ycor >= -21 and ycor <= -10  [
    setxy 90 ycor - 26

    if rand3 = 0 [
      set transfer-exit transfer-tunnel-exit-right-ecsalator-a
      set transfer-exit-steps modify-x-y-values path-from-b-main-to-right-a
    ]

    if rand3 = 1 [
      set transfer-exit transfer-tunnel-exit-middle-ecsalator-a
      set transfer-exit-steps modify-x-y-values  path-from-b-main-to-middle-a
    ]

    if rand3 = 2 [
      set transfer-exit transfer-tunnel-exit-left-ecsalator-a
      set transfer-exit-steps modify-x-y-values path-from-b-main-to-middle-a
    ]
  ]

  ; eskalator A pravo
  if xcor >= 116 and xcor <= 118 and ycor >= -140 and ycor <= -133  [
    setxy xcor - 21 -112

    if rand3 = 0 [
      set transfer-exit transfer-tunnel-exit-main-b
      set transfer-exit-steps modify-x-y-values  path-from-a-right-to-main-b
    ]

    if rand3 = 1 [
      set transfer-exit transfer-tunnel-exit-left-stairs-b
      set transfer-exit-steps modify-x-y-values  path-from-a-right-to-stairs-b
    ]

    if rand3 = 2 [
      set transfer-exit transfer-tunnel-exit-right-stairs-b
      set transfer-exit-steps modify-x-y-values  path-from-a-right-to-stairs-b
    ]
  ]

  ; eskalator A vlevo
  if xcor > 80 and xcor < 82 and ycor > -140 and ycor < -133  [
    setxy xcor + 15 -78

    if rand3 = 0 [
      set transfer-exit transfer-tunnel-exit-main-b
      set transfer-exit-steps modify-x-y-values path-from-a-middle-to-main-b
    ]

    if rand3 = 1 [
      set transfer-exit transfer-tunnel-exit-left-stairs-b
      set transfer-exit-steps modify-x-y-values path-from-a-middle-to-stairs-b
    ]

    if rand3 = 2 [
      set transfer-exit transfer-tunnel-exit-right-stairs-b
      set transfer-exit-steps modify-x-y-values path-from-a-middle-to-stairs-b
    ]
  ]

  ; eskalator A uprostred
  if xcor > 105 and xcor < 107 and ycor > -140 and ycor < -133  [
    setxy xcor - 10 -99

    if rand3 = 0 [
      set transfer-exit transfer-tunnel-exit-main-b
      set transfer-exit-steps modify-x-y-values path-from-a-right-to-main-b
    ]

    if rand3 = 1 [
      set transfer-exit transfer-tunnel-exit-left-stairs-b
      set transfer-exit-steps modify-x-y-values path-from-a-right-to-stairs-b
    ]

    if rand3 = 2 [
      set transfer-exit transfer-tunnel-exit-right-stairs-b
      set transfer-exit-steps modify-x-y-values path-from-a-right-to-stairs-b
    ]
  ]

  set current-step "exit-transfer-tunnels"
end

to exit-transfer-tunnels
  let length-transfer-exit-steps length transfer-exit-steps

  ifelse current-transfer-exit-step >= length-transfer-exit-steps [
    let best-target min-one-of transfer-exit [distance myself]
    face best-target

    ifelse member? patch-ahead pace transfer-exit or distance best-target < pace [
      update-best-results
      die
    ][
      avoid-walls-collision
      attempt-movement
    ]
  ][
    let transfer-step item current-transfer-exit-step transfer-exit-steps
    let x (item 0 transfer-step)
    let y (item 1 transfer-step)
    let transfer-step-patch patch x y
    face transfer-step-patch

    ifelse distance transfer-step-patch <= pace [
      set current-transfer-exit-step 1 + current-transfer-exit-step
      pace-movement
    ] [
      avoid-walls-collision
      attempt-movement
    ]
  ]
end

; HELPERS
to before-movement
  set ttl 50
  set path lput patch-ahead pace path
end

to pace-movement
  set ttl 50
  set path lput patch-ahead pace path
  set path-distance path-distance + pace
  jump pace
end

to attempt-movement
  if [pcolor] of patch-ahead pace = 7.5  [
    pace-movement
  ]

  if [pcolor] of patch-ahead pace = black or [pcolor] of patch-ahead pace = red [
    pace-movement
  ]

  if [pcolor] of patch-ahead pace = 1.6 or [pcolor] of patch-ahead pace = orange [
    before-movement
    jump pace * 0.5
    set path-distance path-distance + pace * 0.5
  ]

  if [pcolor] of patch-ahead pace = 2.5 or [pcolor] of patch-ahead pace = pink  [
    before-movement
    jump 1
    set path-distance path-distance + 1
  ]
end

to avoid-walls-collision
  if [pcolor] of patch-ahead pace = 133.1 [
    let valid-neighbors neighbors with [pcolor = black
      or pcolor = 1.6
      or pcolor = 2.5
      or pcolor = 7.5
      or pcolor = red
      or pcolor = orange
      or pcolor = pink]

    ifelse any? valid-neighbors [
      ifelse random-normal 1 0.2 > 0.6 [
        let closest-patch one-of valid-neighbors
        face closest-patch
      ][
        rt random 180
      ]
    ] [
      rt random 45
    ]
  ]
end

to-report modify-x-y-values [input-list]
  let output-list []
  foreach input-list
    [pair ->
      let x item 0 pair
      let y item 1 pair
      let random-x-sign one-of [-1 1]
      let random-y-sign one-of [-1 1]
      let random-change-x random-normal 1 0.1 * random-x-sign
      let random-change-y random-normal 1 0.1 * random-y-sign
      set output-list lput (list (x + random-change-x) (y + random-change-y)) output-list
  ]
  report output-list
end

to-report get-best-train-exit
  if arriving-in-train = 0 [
    report min-one-of train0-exits [distance myself]
  ]

  if arriving-in-train = 1 [
    report min-one-of train1-exits [distance myself]
  ]

  if arriving-in-train = 2 [
    report min-one-of train2-exits [distance myself]
  ]

  if arriving-in-train = 3 [
    report min-one-of train3-exits [distance myself]
  ]
end

to update-best-results
  if arriving-in-train = 0[
    if path-distance < best-distance-b-i [
      set best-path-b-i path
      set best-distance-b-i path-distance
    ]

    set transfered-to-a-counter transfered-to-a-counter + 1
  ]

  if arriving-in-train = 1[
    if path-distance < best-distance-b-ii [
      set best-path-b-ii path
      set best-distance-b-ii path-distance
    ]

    set transfered-to-a-counter transfered-to-a-counter + 1
  ]

  if arriving-in-train = 2[
    if path-distance < best-distance-a-i [
      set best-path-a-i path
      set best-distance-a-i path-distance
    ]

    set transfered-to-b-counter transfered-to-b-counter + 1
  ]

  if arriving-in-train = 3[
    if path-distance < best-distance-a-ii [
      set best-path-a-ii path
      set best-distance-a-ii path-distance
    ]

    set transfered-to-b-counter transfered-to-b-counter + 1
  ]

end

; DISPLAY
to-report best-path-distance
  if Zobrazovat-nejlepší-přestup-pro = "I-B" [
    report best-distance-b-i
  ]

  if Zobrazovat-nejlepší-přestup-pro = "II-B" [
    report best-distance-b-ii
  ]

  if Zobrazovat-nejlepší-přestup-pro = "I-A" [
    report best-distance-a-i
  ]

  if Zobrazovat-nejlepší-přestup-pro = "II-A" [
    report best-distance-a-ii
  ]
end

to show-best-path
  let best-path (list)

  if Zobrazovat-nejlepší-přestup-pro = "I-B" [
    set best-path best-path-b-i
  ]

  if Zobrazovat-nejlepší-přestup-pro = "II-B" [
    set best-path best-path-b-ii
  ]

  if Zobrazovat-nejlepší-přestup-pro = "I-A" [
    set best-path best-path-a-i
  ]

  if Zobrazovat-nejlepší-přestup-pro = "II-A" [
    set best-path best-path-a-ii
  ]

  if length best-path > 0 [
    clear-best-path

    ask patches [
      if member? self best-path [
        if [pcolor] of self = black[
          set pcolor orange
        ]

        if [pcolor] of self = 1.6[
          set pcolor red
        ]

        if [pcolor] of self = 2.5[
          set pcolor pink
        ]
      ]
    ]
  ]
end

to clear-best-path
  ask patches [
    if [pcolor] of self = orange[
      set pcolor black
    ]

    if [pcolor] of self = red[
      set pcolor 1.6
    ]

    if [pcolor] of self = pink[
      set pcolor 2.5
    ]
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
304
14
870
581
-1
-1
3.7
1
10
1
1
1
0
0
0
1
0
150
-150
0
1
1
1
ticks
30.0

BUTTON
12
565
125
598
SETUP
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
155
566
279
599
GO
go\n
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
11
10
277
146
počet přestupujících
celkem
aktuálně
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot count turtles"

MONITOR
10
159
144
204
aktulaně cestujících
count turtles
17
1
11

MONITOR
163
160
276
205
přestoupilo na B
transfered-to-b-counter
17
1
11

MONITOR
12
219
143
264
čas
count-mins
17
1
11

SLIDER
11
277
277
310
frekvence-prijezdu
frekvence-prijezdu
0
100
100.0
1
1
NIL
HORIZONTAL

MONITOR
6
453
273
498
Délka nejlepšího přestupu
best-path-distance
17
1
11

BUTTON
0
513
143
546
zobraz přestup
show-best-path
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
7
395
273
440
Zobrazovat-nejlepší-přestup-pro
Zobrazovat-nejlepší-přestup-pro
"I-B" "II-B" "I-A" "II-A"
3

MONITOR
162
218
278
263
přestoupilo na A
transfered-to-a-counter
17
1
11

BUTTON
154
512
285
545
schovej přestup
clear-best-path
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
8
332
275
377
cas-simulace
cas-simulace
"7-8" "17-18"
1

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.4.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
